"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayTransformAndValidateSyncTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const UnknownClassError_1 = require("./../src/exceptions/UnknownClassError");
const CustomStorageClass_1 = require("./classes/CustomStorageClass");
const PassClassTransformOption_1 = require("./classes/PassClassTransformOption");
const Product_1 = require("./classes/Product");
const factories_1 = require("./factories");
let ArrayTransformAndValidateSyncTest = class ArrayTransformAndValidateSyncTest {
    normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        Product_1.productValidate(expected, src_1.arrayTransformAndValidateSync(Product_1.Product, expected.toPlainArray()));
    }
    array() {
        const testData = factories_1.factory.make(Product_1.Product).many(2);
        const results = src_1.arrayTransformAndValidateSync(Product_1.Product, testData.map((o) => o.toPlainArray()), { isArray: true });
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(testData.length);
        1;
        for (const [i, expected] of testData.entries()) {
            chai_1.expect(results).property(i.toString());
            Product_1.productValidate(expected, results[i]);
        }
    }
    transformOption() {
        const expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
        const result = src_1.arrayTransformAndValidateSync(PassClassTransformOption_1.PassClassTransformOption, expected.toPlainArray(), {
            transformer: { strategy: 'excludeAll' },
        });
        PassClassTransformOption_1.passClassTransformOptionValidate(expected, result);
    }
    fail() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        const plainArray = expected.toPlainArray();
        plainArray[1] = plainArray[1].toString();
        chai_1.expect(() => src_1.arrayTransformAndValidateSync(Product_1.Product, plainArray)).throw();
    }
    customStorage() {
        const expected = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).one();
        CustomStorageClass_1.customStorageValidate(expected, src_1.arrayTransformAndValidateSync(CustomStorageClass_1.CustomStorageClass, expected.toPlainArray(), { arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage }));
    }
    customStorageFail() {
        const expected = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).one();
        chai_1.expect(() => src_1.arrayTransformAndValidateSync(CustomStorageClass_1.CustomStorageClass, expected.toPlainArray())).throw(UnknownClassError_1.UnknownClassError);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "array", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "transformOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "fail", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "customStorage", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayTransformAndValidateSyncTest.prototype, "customStorageFail", null);
ArrayTransformAndValidateSyncTest = __decorate([
    mocha_1.suite()
], ArrayTransformAndValidateSyncTest);
exports.ArrayTransformAndValidateSyncTest = ArrayTransformAndValidateSyncTest;
//# sourceMappingURL=arrayTransformAndValidateSync.test.js.map