"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shipWithPartialPropertyArrayValidate = exports.shipWithPartialPropertyValidate = exports.ShipWithPartialProperty = exports.shipStoragePartial = exports.shipWithDefaultArrayValidate = exports.shipWithDefaultValidate = exports.ShipWithDefault = exports.shipArrayValidate = exports.shipValidate = exports.Ship = exports.shipStorage = void 0;
const chai_1 = require("chai");
const class_fixtures_factory_1 = require("class-fixtures-factory");
const faker_1 = __importDefault(require("faker"));
const src_1 = require("../../src");
const validate_1 = require("../factories/validate");
exports.shipStorage = new src_1.ArrayMemberStorage();
//
let Ship = class Ship {
    constructor() {
        this.id = 0;
    }
    toPlainArray() {
        return [this.id];
    }
};
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number()),
    __metadata("design:type", Object)
], Ship.prototype, "id", void 0);
Ship = __decorate([
    src_1.ArrayMemberClass(exports.shipStorage)
], Ship);
exports.Ship = Ship;
function shipValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', Ship);
    }
    chai_1.expect(result).property('id', expected.id);
}
exports.shipValidate = shipValidate;
function shipArrayValidate(expected, result) {
    chai_1.expect(result).not.null;
    chai_1.expect(result).property('constructor', Array);
    chai_1.expect(result).property('0', expected.id);
}
exports.shipArrayValidate = shipArrayValidate;
//
let ShipWithDefault = class ShipWithDefault extends Ship {
    constructor() {
        super(...arguments);
        this.name = '';
    }
    toPlainArray() {
        return [...super.toPlainArray(), this.name];
    }
};
__decorate([
    src_1.ArrayMember(1),
    class_fixtures_factory_1.Fixture(() => faker_1.default.name.firstName()),
    __metadata("design:type", Object)
], ShipWithDefault.prototype, "name", void 0);
ShipWithDefault = __decorate([
    src_1.ArrayMemberClass(exports.shipStorage),
    src_1.ArrayMemberClass(src_1.defaultArrayMemberStorage)
], ShipWithDefault);
exports.ShipWithDefault = ShipWithDefault;
function shipWithDefaultValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', ShipWithDefault);
    }
    chai_1.expect(result).property('id', expected.id);
    chai_1.expect(result).property('name', expected.name);
}
exports.shipWithDefaultValidate = shipWithDefaultValidate;
function shipWithDefaultArrayValidate(expected, result) {
    chai_1.expect(result).not.null;
    chai_1.expect(result).property('constructor', Array);
    chai_1.expect(result).property('0', expected.id);
    chai_1.expect(result).property('1', expected.name);
}
exports.shipWithDefaultArrayValidate = shipWithDefaultArrayValidate;
//
exports.shipStoragePartial = new src_1.ArrayMemberStorage();
let ShipWithPartialProperty = class ShipWithPartialProperty {
    constructor() {
        this.id = 0;
        this.name = '';
    }
    toPlainArray() {
        return [this.id, this.name];
    }
};
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number({ min: 1 })),
    __metadata("design:type", Object)
], ShipWithPartialProperty.prototype, "id", void 0);
__decorate([
    src_1.ArrayMember(1, { arrayMemberStorage: exports.shipStoragePartial }),
    class_fixtures_factory_1.Fixture(() => faker_1.default.name.firstName()),
    __metadata("design:type", Object)
], ShipWithPartialProperty.prototype, "name", void 0);
ShipWithPartialProperty = __decorate([
    src_1.ArrayMemberClass(exports.shipStorage)
], ShipWithPartialProperty);
exports.ShipWithPartialProperty = ShipWithPartialProperty;
function shipWithPartialPropertyValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', ShipWithPartialProperty);
    }
    chai_1.expect(result).property('id', expected.id);
    chai_1.expect(result).property('name', expected.name);
}
exports.shipWithPartialPropertyValidate = shipWithPartialPropertyValidate;
function shipWithPartialPropertyArrayValidate(expected, result) {
    chai_1.expect(result).not.null;
    chai_1.expect(result).property('constructor', Array);
    if (expected.id != null) {
        chai_1.expect(result).property('0', expected.id);
    }
    if (expected.name != null) {
        chai_1.expect(result).property('1', expected.name);
    }
}
exports.shipWithPartialPropertyArrayValidate = shipWithPartialPropertyArrayValidate;
//# sourceMappingURL=Ship.js.map