"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayMemberClassTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const common_errors_1 = require("common-errors");
const src_1 = require("../../src");
const customStorage = new src_1.ArrayMemberStorage();
let Test = class Test {
    constructor() {
        this.id = 0;
    }
};
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], Test.prototype, "id", void 0);
Test = __decorate([
    src_1.ArrayMemberClass(customStorage)
], Test);
const customStorage2 = new src_1.ArrayMemberStorage();
let MultiStorage = class MultiStorage {
    constructor() {
        this.id = 0;
    }
};
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], MultiStorage.prototype, "id", void 0);
MultiStorage = __decorate([
    src_1.ArrayMemberClass(customStorage),
    src_1.ArrayMemberClass(customStorage2)
], MultiStorage);
let AllStorage = class AllStorage {
    constructor() {
        this.id = 0;
    }
};
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], AllStorage.prototype, "id", void 0);
AllStorage = __decorate([
    src_1.ArrayMemberClass(customStorage),
    src_1.ArrayMemberClass(customStorage2),
    src_1.ArrayMemberClass(src_1.defaultArrayMemberStorage)
], AllStorage);
let DuplicateStorage = class DuplicateStorage {
    constructor() {
        this.id = 0;
    }
};
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], DuplicateStorage.prototype, "id", void 0);
DuplicateStorage = __decorate([
    src_1.ArrayMemberClass(customStorage),
    src_1.ArrayMemberClass(customStorage)
], DuplicateStorage);
let EmptyProperty = class EmptyProperty {
};
EmptyProperty = __decorate([
    src_1.ArrayMemberClass(customStorage)
], EmptyProperty);
let EmptyStorageParam = class EmptyStorageParam {
    constructor() {
        this.id = 0;
    }
};
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], EmptyStorageParam.prototype, "id", void 0);
EmptyStorageParam = __decorate([
    src_1.ArrayMemberClass()
], EmptyStorageParam);
class Tmp {
    constructor() {
        this.id = 0;
        this.name = '';
    }
}
let ArrayMemberClassTest = class ArrayMemberClassTest {
    normal() {
        const storage = new src_1.ArrayMemberStorage();
        const a = src_1.ArrayMemberClass(storage);
        src_1.ArrayMember(0)(Object.create(Tmp.prototype), 'id');
        a(Tmp);
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(Tmp)).true;
    }
    multipleStorage() {
        const storage1 = new src_1.ArrayMemberStorage();
        const storage2 = new src_1.ArrayMemberStorage();
        const a = src_1.ArrayMemberClass(storage1);
        const b = src_1.ArrayMemberClass(storage2);
        src_1.ArrayMember(0)(Object.create(Tmp.prototype), 'id');
        a(Tmp);
        b(Tmp);
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(Tmp)).true;
        chai_1.expect(storage1.has(Tmp)).true;
        chai_1.expect(storage2.has(Tmp)).true;
    }
    decorators() {
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(Test)).true;
        chai_1.expect(customStorage.has(Test)).true;
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(MultiStorage)).true;
        chai_1.expect(customStorage.has(MultiStorage)).true;
        chai_1.expect(customStorage2.has(MultiStorage)).true;
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(AllStorage)).true;
        chai_1.expect(customStorage.has(AllStorage)).true;
        chai_1.expect(customStorage2.has(AllStorage)).true;
        chai_1.expect(src_1.defaultArrayMemberStorage.has(AllStorage)).true;
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(DuplicateStorage)).true;
        chai_1.expect(customStorage.has(DuplicateStorage)).true;
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(EmptyProperty)).true;
        chai_1.expect(src_1.defaultArrayMemberStorage.has(EmptyStorageParam)).true;
    }
    lateDecorator() {
        const storage = new src_1.ArrayMemberStorage();
        const a = src_1.ArrayMemberClass(storage);
        src_1.ArrayMember(0)(Object.create(Tmp.prototype), 'id');
        a(Tmp);
        src_1.ArrayMember(1)(Object.create(Tmp.prototype), 'name');
        chai_1.expect(src_1.defaultArrayMemberClassStorage.has(Tmp)).true;
        chai_1.expect(storage.has(Tmp)).true;
        const propertyIndexMap = storage.getPropertyIndexMap(Tmp);
        chai_1.expect(propertyIndexMap).not.null;
        const propertyA = propertyIndexMap === null || propertyIndexMap === void 0 ? void 0 : propertyIndexMap.get(0);
        chai_1.expect(propertyA).not.null;
        chai_1.expect(propertyA).property('key', 'id');
        const propertyB = propertyIndexMap === null || propertyIndexMap === void 0 ? void 0 : propertyIndexMap.get(1);
        chai_1.expect(propertyB).not.null;
        chai_1.expect(propertyB).property('key', 'name');
    }
    typeError() {
        chai_1.expect(() => src_1.ArrayMemberClass(true)).throw(common_errors_1.TypeError);
        chai_1.expect(() => src_1.ArrayMemberClass({})).throw(common_errors_1.TypeError);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberClassTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberClassTest.prototype, "multipleStorage", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberClassTest.prototype, "decorators", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberClassTest.prototype, "lateDecorator", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberClassTest.prototype, "typeError", null);
ArrayMemberClassTest = __decorate([
    mocha_1.suite()
], ArrayMemberClassTest);
exports.ArrayMemberClassTest = ArrayMemberClassTest;
//# sourceMappingURL=ArrayMemberClass.test.js.map