"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformClassToPlainArrayTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = __importStar(require("chai"));
const chai_as_promised_1 = __importDefault(require("chai-as-promised"));
const src_1 = require("../../src");
const CustomStorageClass_1 = require("../classes/CustomStorageClass");
const PassClassTransformOption_1 = require("./../classes/PassClassTransformOption");
const Product_1 = require("./../classes/Product");
const factories_1 = require("./../factories");
chai_1.default.use(chai_as_promised_1.default);
class TestToPlainArray {
    constructor() {
        this.expected = factories_1.factory.make(Product_1.Product).one();
    }
    run() {
        return this.expected;
    }
    async runAsync() {
        return this.expected;
    }
}
__decorate([
    src_1.TransformClassToPlainArray(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToPlainArray.prototype, "run", null);
__decorate([
    src_1.TransformClassToPlainArray(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestToPlainArray.prototype, "runAsync", null);
class TestToPlainArrayWithArrayOption {
    constructor() {
        this.expects = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).many(3);
    }
    run() {
        return this.expects;
    }
    async runAsync() {
        return this.expects;
    }
}
__decorate([
    src_1.TransformClassToPlainArray({ arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToPlainArrayWithArrayOption.prototype, "run", null);
__decorate([
    src_1.TransformClassToPlainArray({ arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestToPlainArrayWithArrayOption.prototype, "runAsync", null);
class TestToPlainArrayWithOption {
    constructor() {
        this.expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
    }
    run() {
        return this.expected;
    }
}
__decorate([
    src_1.TransformClassToPlainArray({ strategy: 'excludeAll' }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToPlainArrayWithOption.prototype, "run", null);
let TransformClassToPlainArrayTest = class TransformClassToPlainArrayTest {
    normal() {
        const test = new TestToPlainArray();
        const result = test.run();
        Product_1.productArrayValidate(test.expected, result);
    }
    async async() {
        const test = new TestToPlainArray();
        const result = await test.runAsync();
        Product_1.productArrayValidate(test.expected, result);
    }
    arrayOption() {
        const test = new TestToPlainArrayWithArrayOption();
        const results = test.run();
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(test.expects.length);
        for (const [i, expected] of test.expects.entries()) {
            CustomStorageClass_1.customStorageArrayValidate(expected, results[i]);
        }
    }
    async arrayOptionAsync() {
        const test = new TestToPlainArrayWithArrayOption();
        const results = await test.runAsync();
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(test.expects.length);
        for (const [i, expected] of test.expects.entries()) {
            CustomStorageClass_1.customStorageArrayValidate(expected, results[i]);
        }
    }
    classTransformOption() {
        const test = new TestToPlainArrayWithOption();
        const result = test.run();
        PassClassTransformOption_1.passClassTransformOptionArrayValidate(test.expected, result);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformClassToPlainArrayTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformClassToPlainArrayTest.prototype, "async", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformClassToPlainArrayTest.prototype, "arrayOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformClassToPlainArrayTest.prototype, "arrayOptionAsync", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformClassToPlainArrayTest.prototype, "classTransformOption", null);
TransformClassToPlainArrayTest = __decorate([
    mocha_1.suite()
], TransformClassToPlainArrayTest);
exports.TransformClassToPlainArrayTest = TransformClassToPlainArrayTest;
//# sourceMappingURL=TransformClassToPlainArray.test.js.map