"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformPlainArrayToClassTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = __importStar(require("chai"));
const chai_as_promised_1 = __importDefault(require("chai-as-promised"));
const src_1 = require("../../src");
const CustomStorageClass_1 = require("../classes/CustomStorageClass");
const PassClassTransformOption_1 = require("./../classes/PassClassTransformOption");
const Product_1 = require("./../classes/Product");
const factories_1 = require("./../factories");
chai_1.default.use(chai_as_promised_1.default);
class TestToClass {
    constructor() {
        this.expected = factories_1.factory.make(Product_1.Product).one();
    }
    run() {
        return this.expected.toPlainArray();
    }
    async runAsync() {
        return this.expected.toPlainArray();
    }
}
__decorate([
    src_1.TransformPlainArrayToClass(Product_1.Product),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToClass.prototype, "run", null);
__decorate([
    src_1.TransformPlainArrayToClass(Product_1.Product),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestToClass.prototype, "runAsync", null);
class TestToClassWithArrayOption {
    constructor() {
        this.expects = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).many(3);
    }
    run() {
        return this.expects.map((o) => o.toPlainArray());
    }
    async runAsync() {
        return this.expects.map((o) => o.toPlainArray());
    }
}
__decorate([
    src_1.TransformPlainArrayToClass(CustomStorageClass_1.CustomStorageClass, { arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage, isArray: true }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToClassWithArrayOption.prototype, "run", null);
__decorate([
    src_1.TransformPlainArrayToClass(CustomStorageClass_1.CustomStorageClass, { arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage, isArray: true }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestToClassWithArrayOption.prototype, "runAsync", null);
class TestToClassWithOption {
    constructor() {
        this.expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
    }
    run() {
        return this.expected.toPlainArray();
    }
}
__decorate([
    src_1.TransformPlainArrayToClass(PassClassTransformOption_1.PassClassTransformOption, { strategy: 'excludeAll' }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestToClassWithOption.prototype, "run", null);
let TransformPlainArrayToClassTest = class TransformPlainArrayToClassTest {
    normal() {
        const test = new TestToClass();
        const result = test.run();
        Product_1.productValidate(test.expected, result);
    }
    async async() {
        const test = new TestToClass();
        const result = await test.runAsync();
        Product_1.productValidate(test.expected, result);
    }
    arrayOption() {
        const test = new TestToClassWithArrayOption();
        const results = test.run();
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(test.expects.length);
        for (const [i, expected] of test.expects.entries()) {
            CustomStorageClass_1.customStorageValidate(expected, results[i]);
        }
    }
    async arrayOptionAsync() {
        const test = new TestToClassWithArrayOption();
        const results = await test.runAsync();
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(test.expects.length);
        for (const [i, expected] of test.expects.entries()) {
            CustomStorageClass_1.customStorageValidate(expected, results[i]);
        }
    }
    classTransformOption() {
        const test = new TestToClassWithOption();
        const result = test.run();
        PassClassTransformOption_1.passClassTransformOptionValidate(test.expected, result);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformPlainArrayToClassTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformPlainArrayToClassTest.prototype, "async", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformPlainArrayToClassTest.prototype, "arrayOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformPlainArrayToClassTest.prototype, "arrayOptionAsync", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformPlainArrayToClassTest.prototype, "classTransformOption", null);
TransformPlainArrayToClassTest = __decorate([
    mocha_1.suite()
], TransformPlainArrayToClassTest);
exports.TransformPlainArrayToClassTest = TransformPlainArrayToClassTest;
//# sourceMappingURL=TransformPlainArrayToClass.test.js.map