"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var IndexTest_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndexTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = __importStar(require("chai"));
const chai_as_promised_1 = __importDefault(require("chai-as-promised"));
const classTransformerValidator = __importStar(require("class-transformer-validator"));
const sinon_1 = __importDefault(require("sinon"));
const src_1 = require("../src");
chai_1.default.use(chai_as_promised_1.default);
const sandbox = sinon_1.default.createSandbox();
const value = Object.create(null);
const func = () => value;
class TransformTest {
    plainArrayToClass() {
        return value;
    }
    async plainArrayToClassAsync() {
        return value;
    }
    classToPlainArray() {
        return value;
    }
    async classToPlainArrayAsync() {
        return value;
    }
}
__decorate([
    src_1.TransformPlainArrayToClass(TransformTest),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformTest.prototype, "plainArrayToClass", null);
__decorate([
    src_1.TransformPlainArrayToClass(TransformTest),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformTest.prototype, "plainArrayToClassAsync", null);
__decorate([
    src_1.TransformClassToPlainArray(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TransformTest.prototype, "classToPlainArray", null);
__decorate([
    src_1.TransformClassToPlainArray(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TransformTest.prototype, "classToPlainArrayAsync", null);
let IndexTest = IndexTest_1 = class IndexTest {
    constructor() {
        this.transformTest = new TransformTest();
    }
    plainMapValue() {
        chai_1.expect(src_1.plainMapValue(IndexTest_1, [])).equal(value);
    }
    classMapValue() {
        chai_1.expect(src_1.classMapValue(IndexTest_1, Object())).equal(value);
    }
    plainArrayToClass() {
        chai_1.expect(src_1.plainArrayToClass(IndexTest_1, [])).equal(value);
    }
    classToPlainArray() {
        chai_1.expect(src_1.classToPlainArray(Object())).equal(value);
    }
    async arrayTransformAndValidate() {
        chai_1.expect(await src_1.arrayTransformAndValidate(IndexTest_1, [])).equal(value);
    }
    arrayTransformAndValidateSync() {
        chai_1.expect(src_1.arrayTransformAndValidateSync(IndexTest_1, [])).equal(value);
    }
    transformPlainArrayToClass() {
        chai_1.expect(this.transformTest.classToPlainArray()).equal(value);
    }
    async transformPlainArrayToClassAsync() {
        chai_1.expect(await this.transformTest.plainArrayToClassAsync()).equal(value);
    }
    transformClassToPlainArray() {
        chai_1.expect(this.transformTest.classToPlainArray()).equal(value);
    }
    async transformClassToPlainArrayAsync() {
        chai_1.expect(await this.transformTest.classToPlainArrayAsync()).equal(value);
    }
    before() {
        sandbox.stub(src_1.ClassTransformerForArray, 'instance').value({
            plainMapValue: func,
            classMapValue: func,
            plainArrayToClass: func,
            classToPlainArray: func,
            arrayTransformAndValidate: func,
            arrayTransformAndValidateSync: func,
        });
        sandbox.stub(classTransformerValidator, 'transformAndValidate').callsFake(() => value);
        sandbox.stub(classTransformerValidator, 'transformAndValidateSync').callsFake(() => value);
    }
    after() {
        sandbox.restore();
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "plainMapValue", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "classMapValue", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "plainArrayToClass", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "classToPlainArray", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], IndexTest.prototype, "arrayTransformAndValidate", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "arrayTransformAndValidateSync", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "transformPlainArrayToClass", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], IndexTest.prototype, "transformPlainArrayToClassAsync", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IndexTest.prototype, "transformClassToPlainArray", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], IndexTest.prototype, "transformClassToPlainArrayAsync", null);
IndexTest = IndexTest_1 = __decorate([
    mocha_1.suite('make sure its proxy over static instance')
], IndexTest);
exports.IndexTest = IndexTest;
//# sourceMappingURL=index.test.js.map