"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StorageTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const storages_1 = require("../src/storages");
const CustomStorageClass_1 = require("./classes/CustomStorageClass");
class Tmp {
    constructor() {
        this.id = 0;
    }
}
class TmpNotExists {
    constructor() {
        this.id = 0;
    }
}
let StorageTest = class StorageTest {
    normal() {
        chai_1.expect(CustomStorageClass_1.arrayMemberStorage.has(CustomStorageClass_1.CustomStorageClass)).true;
        chai_1.expect(storages_1.defaultArrayMemberStorage.has(CustomStorageClass_1.CustomStorageClass)).false;
    }
    add() {
        const storage = new storages_1.ArrayMemberStorage();
        const index = 0;
        const propertyInfo = new storages_1.PropertyInfo('id');
        storage.add(Tmp, index, propertyInfo);
        chai_1.expect(storage.map.has(Tmp)).true;
        const propertyIndexMap = storage.map.get(Tmp);
        chai_1.expect(propertyIndexMap).a(Map.name);
        chai_1.expect(propertyIndexMap === null || propertyIndexMap === void 0 ? void 0 : propertyIndexMap.get(index)).equal(propertyInfo);
    }
    has() {
        const storage = new storages_1.ArrayMemberStorage();
        const index = 0;
        const propertyInfo = new storages_1.PropertyInfo('id');
        storage.add(Tmp, index, propertyInfo);
        chai_1.expect(storage.has(Tmp)).true;
        chai_1.expect(storage.has(TmpNotExists)).false;
    }
    getPropertyIndexMap() {
        const storage = new storages_1.ArrayMemberStorage();
        const index = 0;
        const propertyInfo = new storages_1.PropertyInfo('id');
        storage.add(Tmp, index, propertyInfo);
        const propertyIndexMap = storage.getPropertyIndexMap(Tmp);
        chai_1.expect(propertyIndexMap).a(Map.name);
        chai_1.expect(propertyIndexMap === null || propertyIndexMap === void 0 ? void 0 : propertyIndexMap.get(index)).equal(propertyInfo);
    }
    defaultArrayMemberStorageSame() {
        chai_1.expect(storages_1.ArrayMemberStorage).property('defaultArrayMemberStorage', storages_1.defaultArrayMemberStorage);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StorageTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StorageTest.prototype, "add", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StorageTest.prototype, "has", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StorageTest.prototype, "getPropertyIndexMap", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StorageTest.prototype, "defaultArrayMemberStorageSame", null);
StorageTest = __decorate([
    mocha_1.suite()
], StorageTest);
exports.StorageTest = StorageTest;
//# sourceMappingURL=storage.test.js.map